<?php

include_once('clsCHL.php');
include_once('SOAPTweener.php');

class MSN
{
	var $server	= 'messenger.hotmail.com';
	var $port = 1863;

	var $nexus = 'https://nexus.passport.com/rdr/pprdr.asp';
	var $ssh_login = 'login.live.com/login2.srf';
	//var $ssh_login = 'login.live.com/RST.srf';
/*
    var $protocol = 'MSNP15';
    var $buildver = '8.1.0178';
    var $prod_key = 'PK}_A_0N_K%O?A9S';
    var $prod_id = 'PROD0114ES4Z%Q5W';
*/
    var $protocol = 'MSNP13';
    var $buildver = '8.0.0812';
    var $prod_key = 'RH96F{PHI8PPX_TJ';
    var $prod_id = 'PROD0112J1LW7%NB';
    /*
    var $buildver = '8.0.0328';
    var $prod_key = 'O4BG@C7BWLYQX?5G';
    var $prod_id = 'PROD01065C%ZFN6F';
    */
    var $ticket = '';
    var $lockkey = '';

    var $curl_bin = 0;
	var $debug = true;
    var $id;
    var $fp;
    var $error = '';

	function connect($passport, $password)
	{
        $this->trID = 1;
        /*
		$this->id = 1;
        $this->fp = @fsockopen($this->server, $this->port, $errno, $errstr, 5);
        if (!$this->fp) {
            $this->error = "Can't connect to $this->server:$this0->port, error => $errno, $errstr";
            return false;
        }

        $this->_put("VER $this->id MSNP13 MSNP9 MSNP8 CVR0");
        */
		if ($this->fp = @fsockopen($this->server, $this->port, $errno, $errstr, 2))
		{
			$this->_put("VER $this->trID $this->protocol CVR0\r\n");

			while (! feof($this->fp))
			{
				$data = $this->_get();
				switch ($code = substr($data, 0, 3))
				{
					default:
                        if (is_numeric($code)) {
                            echo $this->_get_error($code)."\n";
                            return false;
                        }
					break;
                    case 'GCF':
                        list(,,$x) =  explode(' ', $data);
                        //$num = base_convert(trim($x), 16, 10);
                        $num = trim($x);
                        echo "Read data for $num\n";
                        $data = $this->_read($num);
                        //echo "Data: $data\n";
                        echo "read data done!\n";
                        $data = '';
                        break;

					case 'VER':
						$this->_put("CVR $this->trID 0x0409 winnt 5.1 i386 MSMSGS $this->buildver msmsgs $passport\r\n");
					break;
					case 'CVR':
						$this->_put("USR $this->trID TWN I $passport\r\n");
                        // MSNP13 use SSO
						//$this->_put("USR $this->trID SSO I $passport\r\n");
					break;
					case 'XFR':
						list(, , , $ip)  = explode (' ', $data);
						list($ip, $port) = explode (':', $ip);

                        echo "Reconnect to $ip:$port\n";
						if ($this->fp = @fsockopen($ip, $port, $errno, $errstr, 2))
						{
							//$this->trID = 1;

							$this->_put("VER $this->trID $this->protocol CVR0\r\n");
						}
						else
						{
							if (! empty($this->debug)) echo 'Unable to connect to msn server (transfer)';

							return false;
						}
					break;
					case 'USR':
						if (isset($this->authed))
						{
							return true;
						}
						else
						{
							$this->passport = $passport;
							$this->password = urlencode($password);

							list(,,,, $code) = explode(' ', trim($data));
                            $ticketOBJ = new SOAPTweener;
                            $ticket = $ticketOBJ->_fetchticket($passport,$password,$code);
                            if ($ticket == 1) {
								if (! empty($this->debug)) echo 'auth failed';
								return false;
                            }
                            $this->ticket = $ticket;
                            $this->_put("USR $this->trID TWN S $ticket\r\n");
                            $this->authed = 1;
/*
							if ($auth = $this->_ssl_auth_passport3($code))
							{
								$this->_put("USR $this->trID TWN S $auth\r\n");
								//$this->_put("USR $this->trID SSO S t=mspauth&p=mspprof $auth\r\n");

								$this->authed = 1;
							}
							else
							{
								if (! empty($this->debug)) echo 'auth failed';

								return false;
							}
*/
						}
					break;
				}
			}
		}
		else
		{
			if (! empty($this->debug)) echo 'Unable to connect to msn server';

			return false;
		}
	}


    // twu2 begin
	// function rx_data()
    // twu2 end
	function rx_data($my_msg, $to_email)
	{
        //$this->_put("GCF $this->trID Shields.xml\r\n");
		//$this->_put("SYN $this->trID 0\r\n");
		//$this->_put("CHG $this->trID NLN ".time()."\r\n");
		//$this->_put("BLP $this->trID BL\r\n");

        $pid = -1;
        $sent = false;
        $start = time();
        $state = 0;
        $wait_offline = false;
		while (! feof($this->fp))
		{
            /*
            // we are the parent
            if ($pid != -1 && pcntl_waitpid($pid, &$temp, WNOHANG) > 0) {
                echo "child already exit!\n";
                $this->_put("OUT\r\n");
                break;
            }
            */
            if ($sent) {
                if ($wait_offline == false) {
                    $this->_put("OUT\r\n");
                    break;
                }
            }
			$data = $this->_get();

			if ($data)
            {
                $p = strstr($data, '</NOTIFICATION>');
                if ($p) {
                    $len = strlen('</NOTIFICATION>');
                    $data = substr($p, $len);
                    echo "Change to $data\n";
                    if ($data === '') continue;
                }
				//echo $data."\n";

				switch($code = substr($data, 0, 3))
				{
					default:
						// uncommenting this line here would probably give a load of "error code not found" messages.
                        if (is_numeric($code))
                            echo $this->_get_error($code);
					break;
                    case 'SBS':
						$x = explode (' ', trim($data));
                        if ($x[2] == 'null') {
                            echo "Read data until null\n";
                            $data = $this->_readnull();
                            //echo "Data: $data\n";
                            echo "read data done!\n";
                            $data = '';
                        }
                        else if (is_numeric($x[2])) {
                            $num = $x;
                            echo "Read data for $num\n";
                            $data = $this->_read($num);
                            //echo "Data: $data\n";
                            echo "read data done!\n";
                            $data = '';
                        }
                        $state = 2;
                        $this->_put("CHG $this->trID NLN\r\n");
                        break;

                    case 'MSG':
						$x = explode (' ', trim($data));
                        if (is_numeric($x[3])) {
                            $num = $x[3];
                            echo "Read data for $num\n";
                            $data = $this->_read($num);
                            //echo "Data: $data\n";
                            echo "read data done!\n";
                            $data = '';
                        }
                        break;

					case 'CHL':
						$bits = explode (' ', trim($data));
/*
						$return = md5($bits[2].'Q1P7W2E4J9R8U3S5');
*/
                        $clsHashCreator = new clsCHLFactory;
                        echo $bits[2]."\n";
                        $return = $clsHashCreator->generateCHLHash($bits[2], $this->prod_id, $this->prod_key);
                        $this->lockkey = $return;
						$this->_put("QRY $this->trID $this->prod_id 32\r\n$return");
					break;
                    case 'QRY':
                        if ($wait_offline) {
                            foreach ($offline_emails as $to) {
                                $this->sendOIM($to, $my_msg);
                            }
                            $wait_offline = false;
                        }
                        break;
                    // twu2 begin
                    case '715':
                    case 'LST':
                        if ($state == 0) {
                            $state = 2;
                            $this->_put("CHG $this->trID NLN\r\n");
                        }
                        break;
                    case 'CHG':
                        if ($state == 2) {
                            $state = 3;
                            //$this->_put("BLP $this->trID BL\r\n");
                            $start = time();
                            $this->_put("XFR $this->trID SB\r\n");
                        }
                        break;
                    case 'BLP':
                        if ($state == 2) {
                            $state = 3;
                            $start = time();
                            $this->_put("XFR $this->trID SB\r\n");
                        }
                        break;
                    case 'XFR':
                        @list($xfr,,, $server,, $as) = explode(' ', $data);
                        list($server, $port) = explode(':', $server);
/*
$para['server'] = $server;
$para['port'] = $port;
$para['cki'] = trim($as);
$para['from'] = $this->passport;
$para['to'] = $to_email;
$para['msg'] = $my_msg;
$serial = base64_encode(serialize($para));
echo("execute => ./sb.php $serial\n");
system("./sb.php $serial");
*/
                        $sbsess = new switchboard;
                        list($rc, $offline_emails) = $sbsess->doit($server, $port, trim($as), $this->passport, $my_msg, $to_email);
                        //$rc = $sbsess->tx_im($server_data, $my_msg, $this->passport, $to_email);
                        $sbsess->im_close();
                        if (count($offline_emails) > 0) {
                            $wait_offline = true;
                        }
                        if ($wait_offline) {
                            foreach ($offline_emails as $to) {
                                $this->sendOIM($to, $my_msg);
                            }
                            $wait_offline = false;
                        }
                        $sent = true;
                        break;
                    // twu2 end
					case 'RNG':
						// someone's trying to talk to us
						list(, $sid, $server, , $as, $email, $name) = explode(' ', $data);
						list($sb_ip, $sb_port) = explode(':', $server);


						$sbsess = new switchboard;

						if ($sbsess->auth($sb_ip, $sb_port, $this->passport, $sid, $as))
						{
							// sb session opened
							// recieve users message
							if ($msg = $sbsess->rx_im())
							{
								// send the message straight back!
								$sbsess->tx_im(false, $msg, $this->passport, $email);

								// close IM sessions
								$sbsess->im_close();
							}
							else
							{
								echo 'No message was received from user.';
							}
						}
						else
						{
							echo 'Unable to authenticate with switchboard.';
						}
					break;
				}
			}
            else {
                // no data here
                switch ($state) {
                    case 0:
                        $state = 1;
                        $this->_put("CHG $this->trID NLN ".time()."\r\n");
                        break;

                    case 1:
                        $state = 2;
                        $this->_put("BLP $this->trID BL\r\n");
                        break;

                    case 2:
                        $state = 3;
                        $start = time();
                        $this->_put("XFR $this->trID SB\r\n");
                        break;

                    case 3:
                        $now = time();
                        if ($now >= $start)
                            $len = $now - $start;
                        else
                            $len = $now;
                        if ($lne > 20)
                            $sent = true;
                        break;

                    default:
                        break;
                }
            }
		}
	}

    function sendOIM($to, $msg)
    {
        $XML = '<?xml version="1.0" encoding="utf-8"?>'
.'<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">'
.'<soap:Header><From memberName="'.$this->passport.'" friendlyName="=?utf-8?B?'.base64_encode($this->passport).'?=" xml:lang="en-US" proxy="MSNMSGR" xmlns="http://messenger.msn.com/ws/2004/09/oim/" msnpVer="'.$this->protocol.'" buildVer="'.$this->buildver.'"/>'
.'<To memberName="'.$to.'" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>'
.'<Ticket passport="'.$this->ticket.'" appid="'.$this->prod_id.'" lockkey="'.$this->lockkey.'" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>'
.'<Sequence xmlns="http://schemas.xmlsoap.org/ws/2003/03/rm">'
.'<Identifier xmlns="http://schemas.xmlsoap.org/ws/2002/07/utility">http://messenger.msn.com</Identifier>'
.'<MessageNumber>1</MessageNumber>'
.'</Sequence>'
.'</soap:Header>'
.'<soap:Body>'
.'<MessageType xmlns="http://messenger.msn.com/ws/2004/09/oim/">text</MessageType>'
.'<Content xmlns="http://messenger.msn.com/ws/2004/09/oim/">'.
'MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: base64
    X-OIM-Message-Type: OfflineMessage
    X-OIM-Run-Id: {3A3BE82C-684D-4F4F-8005-CBE8D4F82BAD}
    X-OIM-Sequence-Num: 1

    '.base64_encode($msg).'
</Content></soap:Body></soap:Envelope>';
/*
<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Header><From memberName="mail@teatime.com.tw" friendlyName="=?utf-8?B?bWFpbEB0ZWF0aW1lLmNvbS50dw==?=" xml:lang="nl-nl" proxy="MSNMSGR" xmlns="http://messenger.msn.com/ws/2004/09/oim/" msnpVer="MSNP13" buildVer="8.0.0812"/>
<To memberName="twu2_l2s@hotmail.com" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>
<Ticket passport="t=9cbiVsvf8BJmTusE3t25w85mgFMjfwKofp3hySzNp6nREsWI8rk*wFxbKL9*wrybfjzAnd109N9jcDUWL2Z2tM0H1Zykj*pmG6f55ZqQUXGxibiIOiXi8146SkOACd0k3kNUW6n*I3u28$&p=9rNJJapfADq8ZyJYchegWsqxoafKZRHrP0efsJQfXQVtBR1sYpXvpaJOtY0JaeR6IR86wTWtoMVsGOM8Ro9kX0hvLFIigYIuBA7sWSfKdZT08*3NC8LgaZVSOi71AflYBr3ZGDtOPyx3uF*fnyv9ejF3p7DFtWOPWntJhymY1WvVb4loDN*aWreg$$"
appid="PROD0112J1LW7%NB" lockkey="e93645dd36b63e750eecf3657f507fda" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>
<Sequence xmlns="http://schemas.xmlsoap.org/ws/2003/03/rm">
<Identifier xmlns="http://schemas.xmlsoap.org/ws/2002/07/utility">http://messenger.msn.com</Identifier>
<MessageNumber>1</MessageNumber></Sequence></soap:Header><soap:Body>
<MessageType xmlns="http://messenger.msn.com/ws/2004/09/oim/">text</MessageType>
<Content xmlns="http://messenger.msn.com/ws/2004/09/oim/">MIME-Version: 1.0
    Content-Type: text/plain; charset=UTF-8
    Content-Transfer-Encoding: base64
    X-OIM-Message-Type: OfflineMessage
    X-OIM-Run-Id: {3A3BE82C-684D-4F4F-8005-CBE8D4F82BAD}
    X-OIM-Sequence-Num: 1

    5Lit5paH5ris6Kmm
</Content></soap:Body></soap:Envelope>

<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Header><From memberName="tommyga_bandit@hotmail.com" friendlyName="=?utf-8?B?VG9tbXlCb3k=?=" xml:lang="en-US" proxy="MSNMSGR" xmlns="http://messenger.msn.com/ws/2004/09/oim/" msnpVer="MSNP13" buildVer="8.0.0812"/>
<To memberName="tommyga@bandit.it" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>
<Ticket passport="t=90KZoyV5yHDUUPl6aL78soTEkuE2xmTrqVD!t7RYmFyEaaNAhB*qp8phSFFhTuRkrX9mlT9hE0JJGxNqYhJCeef4RW2ZFmewTQbhngh67w1OmxfHFJGr7RfVPVChl6GdJ2oSk3797DH7w$&amp;p=9jhdN4!X!FnTU*IRCzVYwW8kMybhIRs5wfSgG!Ey0Km!tvY2vk6XysJHmVY2onNpzTR2VwaERuE8EeTBU*isZqAqIWve31PCCRyGX2*em5qgS8jqQ8zOMWmgpuzCCp5ukOiLcC*kYpgzZK5vNRqQGINSv7B3fwM63PPIUx9zuh0f8OS7kLkdJT*3sPn3WdKGUxQBQ7fidI3XBJmWiU!6M8Yw$$"
appid="PROD01065C%ZFN6F" lockkey="" xmlns="http://messenger.msn.com/ws/2004/09/oim/"/>
<Sequence xmlns="http://schemas.xmlsoap.org/ws/2003/03/rm">
<Identifier xmlns="http://schemas.xmlsoap.org/ws/2002/07/utility">http://messenger.msn.com</Identifier>
<MessageNumber>1</MessageNumber></Sequence></soap:Header><soap:Body>
<MessageType xmlns="http://messenger.msn.com/ws/2004/09/oim/">text</MessageType>
<Content xmlns="http://messenger.msn.com/ws/2004/09/oim/">MIME-Version: 1.0

Content-Type: text/plain; charset=UTF-8

Content-Transfer-Encoding: base64

X-OIM-Message-Type: OfflineMessage

X-OIM-Run-Id: {3A3BE82C-684D-4F4F-8005-CBE8D4F82BAD}

X-OIM-Sequence-Num: 1



cHJvdmEgT0lN</Content></soap:Body></soap:Envelope>
*/
        $header_array = array(
                                'SOAPAction: http://messenger.live.com/ws/2006/09/oim/Store2',
                                'Content-Type: text/xml',
                                'User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; Messenger '.$this->buildver.')'
                            );
            var_dump($header_array);
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, 'https://ows.messenger.msn.com/OimWS/oim.asmx');
        curl_setopt($curl, CURLOPT_HTTPHEADER, $header_array);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_HEADER, 1);
        curl_setopt($curl, CURLOPT_POST,1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $XML);
        /* Execute! */
        echo "Attempting request.\n$XML\n";
        $data = curl_exec($curl);
        curl_close($curl);
        echo "Result:\n$data\n";
        return;
    }

	/*====================================*\
		Various private functions
	\*====================================*/

	function _ssl_auth($auth_string)
	{
		if (empty($this->ssh_login))
		{
			if ($this->curl_bin)
			{
				exec("$this->curl -m 60 -LkI $this->nexus", $header);
				$header = implode($header, null);
			}
			else
			{
				$ch = curl_init($this->nexus);

				curl_setopt($ch, CURLOPT_HEADER, 1);
				curl_setopt($ch, CURLOPT_NOBODY, 1);
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				// curl_setopt($ch, CURLOPT_TIMEOUT, 2);

				$header = curl_exec($ch);

				curl_close($ch);
			}

			preg_match ('/DALogin=(.*?),/', $header, $out);

			if (isset($out[1]))
			{
				$slogin = $out[1];
			}
			else
			{
				return false;
			}
		}
		else
		{
			$slogin = $this->ssh_login;
		}


		if ($this->curl_bin)
		{
			$header1 = '"Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in='.$this->passport.',pwd='.$this->password.','.$auth_string.'"';

			exec("$this->curl -m 60 -LkI -H $header1 https://$slogin", $auth_string);

			$header = null;

			foreach ($auth_string as $key => $value)
			{
				if (strstr($value, 'Unauthorized'))
				{
					echo 'Unauthorised';
					return false;
				}
				elseif (strstr($value, 'Authentication-Info'))
				{
					$header = $value;
				}
			}
		}
		else
		{
			$ch = curl_init('https://'.$slogin);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array(
							'Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in='.$this->passport.',pwd='.$this->password.','.$auth_string,
							'Host: login.passport.com'
							));

			curl_setopt($ch, CURLOPT_HEADER, 1);
			curl_setopt($ch, CURLOPT_NOBODY, 1);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			// curl_setopt($ch, CURLOPT_TIMEOUT, 2);

			$header = curl_exec($ch);

			curl_close($ch);
		}

		preg_match ("/from-PP='(.*?)'/", $header, $out);

		return (isset($out[1])) ? $out[1] : false;
	}

    function _readnull()
    {
        $data = '';
        $last_line = false;
        $count = 0;
        while (!feof($this->fp)) {
            $cur_line = @fgets($this->fp);
            $data .= $cur_line;
            if ($cur_line == "\r\n") break;
            $last_line = $cur_line;
        }
        if ($this->debug) echo "<<< DATA for null\n$data\n";
        return $data;
    }

    function _read($num)
    {
        $data = '';
        $count = 0;
        while (!feof($this->fp)) {
            $x = @fread($this->fp, $num - $count);
            $data .= $x;
            $count += strlen($x);
            if ($count >= $num) break;
        }
        if ($this->debug) echo "<<< DATA for $num ($count) bytes\n$data\n";
        return $data;
    }

	function _get($num = 0)
	{
        //stream_set_timeout($this->fp, 1);
		if ($data = @fgets($this->fp, 4096))
		{
			if ($this->debug) echo "<<< $data";

			return $data;
		}
		else
		{
			return false;
		}
	}


	function _put($data)
	{
		fwrite($this->fp, $data);

		$this->trID++;

		if ($this->debug) echo ">>> $data";
	}


	function _get_error($code)
	{
		switch ($code)
		{
			case 201:
				return 'Error: 201 Invalid parameter';
			break;
			case 217:
				return 'Error: 217 Principal not on-line';
			break;
			case 500:
				return 'Error: 500 Internal server error';
			break;
			case 540:
				return 'Error: 540 Challenge response failed';
			break;
			case 601:
				return 'Error: 601 Server is unavailable';
			break;
			case 710:
				return 'Error: 710 Bad CVR parameters sent';
			break;
			case 713:
				return 'Error: 713 Calling too rapidly';
			break;
			case 731:
				return 'Error: 731 Not expected';
			break;
			case 800:
				return 'Error: 800 Changing too rapidly';
			break;
			case 910:
			case 921:
				return 'Error: 910/921 Server too busy';
			break;
			case 911:
				return 'Error: 911 Authentication failed';
			break;
			case 923:
				return 'Error: 923 Kids Passport without parental consent';
			break;
			case 928:
				return 'Error: 928 Bad ticket';
			break;
			default:
				return 'Error code '.$code.' not found';
			break;
		}
	}

}


?>
